﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace Flex_Searching_CS
{
    public partial class Form1 : Form
    {
        DataTable dt = new DataTable();
        bool _StartSearch;
        public Form1()
        {
            InitializeComponent();
            dt.Columns.Add("CustomerID",typeof(int));
            dt.Columns.Add("ContactName", typeof(string));
            dt.Columns.Add("Designation", typeof(string));
            dt.Columns.Add("Country", typeof(string));

            //Sample Data
            dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain");
            dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico");
            dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
            dt.Rows.Add(4, "Thomas Hardy", "Sales Representative","UK");
            dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany");
            dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain");
            dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico");
            dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager","UK");
            dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
            dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
            dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
            dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator","Brazil");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Assigning Sample DataSource
            c1FlexGrid1.DataSource = dt;
            c1FlexGrid1.AutoSizeCols();
            //To enable control to fire OwnerDrawCell Event
            c1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw;
            c1FlexGrid1.OwnerDrawCell += c1FlexGrid1_OwnerDrawCell;
        }

        private void tbSearchBox_TextChanged(object sender, EventArgs e)
        {
            //If TextBox contains No Text
            if (tbSearchBox.Text == string.Empty)
            {
                _StartSearch = false;

                C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
                rg.c1 = 1;
                rg.c2 = c1FlexGrid1.Cols.Count - 1;
                rg.r1 = 1;
                rg.r2 = c1FlexGrid1.Rows.Count - 1;
                //Select all cells to redraw their content with default color
                c1FlexGrid1.Select(rg);
                C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
                //Select nothing in Grid
                c1FlexGrid1.Select(rg1);
            }
            //If TextBox contains some text to be searched
            else
            {
                _StartSearch = true;

                C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
                c1FlexGrid1.Select(rg);
                rg.c1 = 1;
                rg.c2 = c1FlexGrid1.Cols.Count - 1;
                rg.r1 = 1;
                rg.r2 = c1FlexGrid1.Rows.Count - 1;
                //Select all cells to search the Grid and redraw search results with Red ForeColor
                c1FlexGrid1.Select(rg);
                //C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
                //c1FlexGrid1.Select(rg1);
            }
        }
        void c1FlexGrid1_OwnerDrawCell(object sender, C1.Win.C1FlexGrid.OwnerDrawCellEventArgs e)
        {
            //Check if OwnerDrawCell used for Searching
            if (_StartSearch)
            {
                //Getting content of cell
                string CellContent = e.Text;
                //Check whether cell contains the Text in TextBox
                if (CellContent.Contains(tbSearchBox.Text))
                {
                    SolidBrush brush = new SolidBrush(Color.Red);
                    Single x = 0;
                    //Traverse celltext and set ForeColor.
                    for (int i = 0; i < CellContent.Length; i++)
                    {
                        string character = CellContent[i].ToString();
                        //Color the Text of Search Result with Red
                        e.Graphics.DrawString(character, c1FlexGrid1.Font, brush, e.Bounds.X + x, e.Bounds.Y);

                        //Next character needs to be shifted right;
                        //depending on the space occupied by the previous character as per its FontSize/FontStyle
                        x += (e.Graphics.MeasureString(character, this.c1FlexGrid1.Font)).Width - 3;
                        
                        //To restrict FlexGrid to draw default cell content
                        e.Handled = true;
                    }
                }
            }
            //Whether Search completed throughout all cells of grid
            if (e.Row == c1FlexGrid1.Rows.Count && e.Col == c1FlexGrid1.Cols.Count)
            {
                _StartSearch = false;
            }
        }

        private void _btnClear_Click(object sender, EventArgs e)
        {
            //Clear the TextBox
            tbSearchBox.Text = string.Empty;
            _StartSearch = false;

            C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
            rg.c1 = 1;
            rg.c2 = c1FlexGrid1.Cols.Count - 1;
            rg.r1 = 1;
            rg.r2 = c1FlexGrid1.Rows.Count - 1;
            //Select all cells to redraw their content with default color
            c1FlexGrid1.Select(rg);
            C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
            //Select nothing in Grid
            c1FlexGrid1.Select(rg1);
        }      
    }
}
